let deIcon = document.createElement('span');
const shadowRoot = deIcon.attachShadow({mode: 'closed'})
const shadowDiv = document.createElement('div');
shadowDiv.innerText = 'Test Btn';
shadowDiv.id = 'de-icon';
shadowRoot.appendChild(shadowDiv);
let tweetBtn;

deIcon.addEventListener('click', () => {
	document.getElementById('iframe-test').contentWindow.postMessage({actionType : 'showGiveDialog'}, '*');
})

document.addEventListener('DOMContentLoaded', function () {
	addIframe();
	setTimeout(() => {
		tweetBtn = document.querySelector('a[data-testid="SideNav_NewTweet_Button"]');
		tweetBtn.addEventListener('click', function () {
		})
	}, 1000)
})

window.addEventListener('message', function (event) {
	if (event.data && event.data.actionType) {
		let iframe = document.getElementById('iframe-test');
		switch (event.data.actionType) {
			case "showIframe":
				iframe.style.display = 'block';
				break;
			case "hideIframe":
				iframe.style.display = 'none';
				break;
			case "showTwitterPublishDialog":
				iframe.style.display = 'none';
				tweetBtn.click();
				break;
		}
	}
	console.log('message',event);
});

function addDeNetBtn (parent, dom, isClick = false) {
	setTimeout(() => {
		if (parent) {
			parent.parentNode.insertBefore(dom, parent.nextSibling);
		} else {
			setTimeout(() => {
				parent = getScheduleDom(isClick);
				parent.parentNode.insertBefore(dom, parent.nextSibling);
			}, 1000)
		}
	})
}

function getScheduleDom (isDialogInner = false) {
	let scheduleBtn;
	if (isDialogInner) {
		scheduleBtn = document.querySelector('div[role="dialog"]').querySelector('[data-testid="createPollButton"]');
	} else {
		// eslint-disable-next-line no-unused-vars
		let toolBar = document.querySelector('div[data-testid="toolBar"]');
		if (toolBar) {
			scheduleBtn = toolBar.querySelector('div[data-testid="createPollButton"]');
		}
	}
	return scheduleBtn;
}

function addIframe () {
	// let span = document.createElement('span');
	// const shadowRoot = span.attachShadow({mode: 'closed'})
	let iframe = document.createElement('iframe');
	iframe.src = chrome.runtime.getURL('/iframe/test.html')
	iframe.id = 'iframe-test'
	iframe.style.cssText = 'position:fixed;top:0px;right:0;display:block; width:100%;height:100%;z-index:1000; border: medium none;display:none';
	// shadowRoot.appendChild(iframe);
	// document.body.appendChild(span)
	document.body.appendChild(iframe)
}

setInterval(() => {
	let toolBar = document.querySelector('div[data-testid="toolBar"]');
	let innerdeIcon = document.getElementById('de-icon');
	if (toolBar && !innerdeIcon) {
		let dialogScheduleBtn = getScheduleDom(false);
		addDeNetBtn(dialogScheduleBtn, deIcon);
	}
}, 800)
